/* Hand Coder: Advanced HTML source edition and ASP/JSP/PHP support.
 * Tri-licence GPL/LGPL/MPL
 * by Fabien Cazenave (aka Kaze)
 */

//
// Nsm dialogs & prefs
var NvuPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
var NvuPublishPrefs = NvuPrefs.getBranch("editor.publish.site_data.");
var hcPrefs = NvuPrefs.getBranch("extensions.HandCoder.");
//~ var NsmApps;

// html Tidy behaviour
const NsmTIDY_OnDemand = 0;
const NsmTIDY_OnSource = 1;
const NsmTIDY_OnSave   = 2;

// Source button behaviour
const NsmSOURCE_Tidy   = -2;
const NsmSOURCE_Editor = -1;
const NsmSOURCE_Freeze = 0;
const NsmSOURCE_Ask    = 1;
const NsmSOURCE_Always = 2;

// CGI open behaviour
const NsmCGI_Never  = 0;
const NsmCGI_Ask    = 1;
const NsmCGI_Always = 2;

// HandCoder.xul (prefs window)
function openFilePicker(msg, elementID, filter) {
/* 	PRInt16  	 modeOpen  	= 0
	PRInt16 	modeSave 	= 1
	PRInt16 	modeGetFolder 	= 2
	PRInt16 	modeOpenMultiple 	= 3
	PRInt16 	returnOK 	= 0
	PRInt16 	returnCancel 	= 1
	PRInt16 	returnReplace 	= 2
	PRInt32 	filterAll 	= 1
	PRInt32 	filterHTML 	= 2
	PRInt32 	filterText 	= 4
	PRInt32 	filterImages 	= 8
	PRInt32 	filterXML 	= 16
	PRInt32 	filterXUL 	= 32
	PRInt32 	filterApps 	= 64
 */	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	fp.init(window, msg, nsIFilePicker.modeOpen);
	if (filter)
		fp.appendFilters(filter);
		//~ fp.appendFilter(nsIFilePicker.filterApps);
	//~ fp.appendFilters(nsIFilePicker.filterHTML | nsIFilePicker.filterImages);
	//~ fp.appendFilters(nsIFilePicker.filterText | nsIFilePicker.filterAll);
	var res = fp.show();
	if (res == nsIFilePicker.returnOK)
		document.getElementById(elementID).value = fp.file.path;
	return;
}

//
// Preferences
function hcGetPrefs() {
	try { // default editor
		document.getElementById("NsmEditor-path").value = hcPrefs.getCharPref("editorPath");
		document.getElementById("NsmEditor-args").value = hcPrefs.getCharPref("editorArgs");
	} catch (e) {}
	
	try { // html Tidy
		document.getElementById("NsmTidy-path").value   = hcPrefs.getCharPref("tidyPath");
		document.getElementById("NsmTidy-args").value   = hcPrefs.getCharPref("tidyArgs");
		document.getElementById("NsmTidy-launch").selectedIndex = hcPrefs.getCharPref("tidyLaunch");
	} catch (e) {}
	
	try { // Struct toolbar
		document.getElementById("StructToolbar-ShowId").checked    = hcPrefs.getBoolPref("ShowId");
		document.getElementById("StructToolbar-ShowClass").checked = hcPrefs.getBoolPref("ShowClass");
		document.getElementById("StructToolbar-ShowAttrs").checked = hcPrefs.getBoolPref("ShowAttrs");
	} catch (e) {}
}

function hcSetPrefs() {
	// default editor
	hcPrefs.setCharPref("editorPath", document.getElementById("NsmEditor-path").value);
	hcPrefs.setCharPref("editorArgs", document.getElementById("NsmEditor-args").value);
	
	// html Tidy
	hcPrefs.setCharPref("tidyPath",   document.getElementById("NsmTidy-path").value);
	hcPrefs.setCharPref("tidyArgs",   document.getElementById("NsmTidy-args").value);
	hcPrefs.setCharPref("tidyLaunch", document.getElementById("NsmTidy-launch").selectedIndex);
	
	// Struct toolbar
	hcPrefs.setBoolPref("ShowId",    document.getElementById("StructToolbar-ShowId").checked);
	hcPrefs.setBoolPref("ShowClass", document.getElementById("StructToolbar-ShowClass").checked);
	hcPrefs.setBoolPref("ShowAttrs", document.getElementById("StructToolbar-ShowAttrs").checked);
	//~ UpdateStructToolbar(); // impossible since we're not in the main window
}

//
// Editor & Tidy launchers (require kazio.js)
function hcLaunchURI(url) {
	if (!url)
		url = GetDocumentUrl();
		
	// http://kb.mozillazine.org/Dev_:_Extensions_:_Example_Code_:_Creating_a_XUL_mailto:_link
	var ioService = Components.classes["@mozilla.org/network/io-service;1"]
		.getService(Components.interfaces.nsIIOService);
	var uri = ioService.newURI(url, null, null);
	var extProtocolSvc = Components.classes["@mozilla.org/uriloader/external-protocol-service;1"]
		.getService(Components.interfaces.nsIExternalProtocolService);
	extProtocolSvc.loadUrl(uri);
}
function hcLaunchEditor(url, sync) {
	if (!url)
		url = GetDocumentUrl();
	
	// launch default editor
	try {
		// get path and args
		var path = hcPrefs.getCharPref("editorPath");
		var argstr = hcPrefs.getCharPref("editorArgs");
		var args = (argstr != "") ? argstr.split(' ') : null;		
		// execute
		var data = NsmFileIO.urlToPath(url);
		var result = NsmFileIO.run(path, data, args, sync);
	} catch (e) {}
	
	return result;
}

function hcLaunchTidy(url, output, isFragment) {
	const NvuDOCTYPE_401STRICT = '<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Strict//EN">';
	const NvuDOCTYPE_CORRECTED = '<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN" '
		+ '"http://www.w3.org/TR/html4/strict.dtd">';
	//~ const NvuFPI_401STRICT = '"-//W3C//DTD HTML 4.01 Strict//EN"';
	//~ const NvuFPI_401STRICT_CORRECTED = '"-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd"';
		
	if (!url)
		url = GetDocumentUrl();
  //~ var editor = GetCurrentEditor();
  //~ if (!aMimeType || aMimeType == "" || !editor)
    //~ throw NS_ERROR_NOT_INITIALIZED;
  //~ var editorDoc = editor.document;
  //~ if (!editorDoc)
    //~ throw NS_ERROR_NOT_INITIALIZED;

	var path = NsmFileIO.urlToPath(url);
	var source = NsmFileIO.read(path);
	var rewrite = false;
	var reload = false;
	
	// get Tidy path and args
	try {
		var TidyPath = hcPrefs.getCharPref("tidyPath");
		var args = hcPrefs.getCharPref("tidyArgs").split(' ');
		// force some prefs to match Nvu output
		args.push("--char-encoding");  // let Nvu handle the charset
		args.push("raw");
		args.push("--fix-uri");        // required for ASP/JSP/PHP attributes!!!
		args.push("no");
		if (output) {    // quick and dirty (should use stdin/stdout instead)
			args.push("--output-file"); 
			args.push(NsmFileIO.urlToPath(output));
		} else {
			args.push("--write-back"); 
			args.push("yes");
		}
		if (isFragment) {              // HTML fragment, tidy <body> only
			args.push("--show-body-only"); 
			args.push("yes");
		} else {                       // HTML document, keep Nvu's doctype
			// this works with the 4 doctypes Nvu can output
			var doctype = cgiGetDoctype(source);
			var strict = (/strict/i.test(doctype)) ? "strict" : "transitional";
			// correct Nvu HTML 4.01 Strict DOCTYPE bug
			if (doctype == NvuDOCTYPE_401STRICT) {
				source = source.replace(NvuDOCTYPE_401STRICT, NvuDOCTYPE_CORRECTED);
				rewrite = true;
			}
			args.push("--doctype");        // doctype
			args.push(strict);
		}
	} catch (e) {}
	
	// replace <br /> by LF in <pre /> nodes (Tidy adds a LF after each <br />)
	var preNodes = source.match(/<pre[^\r\n]*/g);
	if (preNodes) {
		for (var i = 0; i < preNodes.length; i++) 
			source = source.replace(preNodes[i], preNodes[i].replace(/<br \/>/g, '\n').replace(/<br>/g, '\n'));
		rewrite = true;
	}
	
	// TODO: unescape PIs in <title> (modified by Nvu)
	// TODO: unescape PIs in charset (modified by Tidy)
	// TODO: insert &nbsp; before :;!? if requested (for french users)
	// TODO: test the return value and display errors (if any)
	
	// unindent <?php ... ?> contents (Tidy re-indents them)
	const rePHP = /<\?[^\?]*\?>/g;
	//~ source = source.replace(/(<\?[^\?]*\?>)/g, "\n$1\n");
	var phpNodes = source.match(rePHP);
	if (phpNodes) {
		for (i = 0; i < phpNodes.length; i++) {
			if (/[\r\n]/.test(phpNodes[i])) {
				reload = true;
				break;
			}
		}
	}
	
	// execute Tidy
	if (rewrite)
		NsmFileIO.write(path, source);
	var result = NsmFileIO.run(TidyPath, path, args, true);
	
	// replace php nodes if needed (will never work on MacOS X)
	if (reload) {
		source = NsmFileIO.read(path);
		var phpReformatted = source.match(rePHP);
		for (i = 0; i < phpNodes.length; i++)
			source = source.replace(phpReformatted[i], phpNodes[i]);
		NsmFileIO.write(path, source);
	}
	
	return result;
}
/* function hcLaunchOnPI(AppRef) {
	// file IO utilities : see http://www.captain.at/programming/xul/
	var url = GetDocumentUrl();
	var file = /[^\.]*$/.exec(url);
	var fileExt = file[0];
	var tmpPath = NsmFileIO.urlToPath(url + ".tmp." + fileExt);
		
	// get the content of the PHP node (with <?php ?>)
	var phpSelectionFull = GetCurrentEditor().outputToString("text/html", 35); // OutputWrap+OutputFormatted+OutputSelectionOnly
	NsmFileIO.write(tmpPath, cgiUnescapePIs(phpSelectionFull, fileExt));
	
	// launch selected editor and wait for completion
	hcLaunch(AppRef, tmpPath, true);
	
	// get the content of the PHP node (without <?php ?>) and put it in the selected PI
	var value = NsmFileIO.read(tmpPath).replace(/<\?php|<%/, '').replace(/\?>|%>/, '');
	var phpSelectionNode = GetCurrentEditor().getElementOrParentByTagName("php", GetObjectForProperties());
	phpSelectionNode.firstChild.nextSibling.data = value;
	phpSelectionNode.setAttribute("title", value.replace( /\n/g , " "));
	
	// set current page as modified
        //~ document.getElementById("tabeditor").showCurrentTabAsModified(IsDocumentModified() || IsHTMLSourceChanged());
        document.getElementById("tabeditor").showCurrentTabAsModified(true);

	// remove tmp file and return
	NsmFileIO.unlink(tmpPath); // error: access denied (???)
	return;
}
 */
//
// Modified 'UpdateStructToolbar' function (override that in 'comm.jar/editor/content/editor.js')
function onStructToolbarClick(e) {
	if (e.button != 0)
		return;
	alert('coucou !!!');
	//~ StructSelectTag();
	goDoCommand('cmd_insertHTMLWithDialog');
}

function newStructToolbarButton(tag, attr) {
	var ttip, tagId, attrName, attrValue, attref;
	
	button = document.createElementNS(XUL_NS, "toolbarbutton");
	button.setAttribute("value", tag);
	
	// get user prefs
	var ShowId    = false;
	var ShowClass = false;
	var ShowAttrs = false;
	try {
		ShowId    = hcPrefs.getBoolPref("ShowId");
		ShowClass = hcPrefs.getBoolPref("ShowClass");
		ShowAttrs = hcPrefs.getBoolPref("ShowAttrs");
	} catch (e) {};
	
	// Let's add "id" and "class" attributes in the label
	// and other attributes in the tooltip
	ttip = "";
	tagId = "";
	for (attref = 0; attref < attr.length; attref++) {
		attrName  = attr[attref].nodeName;
		attrValue = attr[attref].value;
		if (ShowId && (attrName == "id"))
			tagId = ' id="' + attrValue + '"' + tagId;
		else if (ShowClass && (attrName == "class"))
			tagId += ' class="' + attrValue + '"';
		else if (ShowAttrs)
			ttip += attrName + '="' + attrValue + '" ';
	}
	button.setAttribute("label", "<" + tag + tagId + ">");
	button.setAttribute("value",   tag);
	//~ button.setAttribute("ondblclick", "StructSelectTag(); goDoCommand('cmd_insertHTMLWithDialog');");
	//~ button.setAttribute("onclick", "onStructToolbarClick(this.event)");
	
	if (ttip != "")
		button.setAttribute("tooltiptext", ttip);
	
	//~ button.addEventListener("click", onStructToolbarClick, true);
	//~ button.addEventListener("click", onStructToolbarClick, false);
	
	return button;
}
function UpdateStructToolbar() {
  var editor = GetCurrentEditor();
  if (!editor) return;

  var mixed = GetSelectionContainer();
  if (!mixed) return;
  var element = mixed.node;
  var oneElementSelected = mixed.oneElementSelected;

  if (!element) return;

  NotifyProcessors(kProcessorsWhenSelectionChanges, element);

  if (element == gLastFocusNode &&
      oneElementSelected == gLastFocusNodeWasSelected)
    return;

  gLastFocusNode = element;
  gLastFocusNodeWasSelected = mixed.oneElementSelected;

  var toolbar = document.getElementById("structToolbar");
  if (!toolbar) return;
  var childNodes = toolbar.childNodes;
  var childNodesLength = childNodes.length;
  // We need to leave the <label> to flex the buttons to the left
  // so, don't remove the last child at position length - 1
  for (var i = childNodesLength - 2; i >= 0; i--) {
    toolbar.removeChild(childNodes.item(i));
  }

  toolbar.removeAttribute("label");

  if ( IsInHTMLSourceMode() ) {
    // we have destroyed the contents of the status bar and are
    // about to recreate it ; but we don't want to do that in
    // Source mode
    return;
  }

  // XXXXXX
  if (true)
  {
    UpdateRulers(element);
    if (!gScrollListener)
      gScrollListener        = GetCurrentEditor().document.addEventListener("scroll", UpdateRulerRequestListener, false);
    if (!gResizeListener)
      gResizeListener        = window.addEventListener("resize", UpdateRulerRequestListener, false);
    if (!gEditorUpdatedListener)
      gEditorUpdatedListener = GetCurrentEditor().document.addEventListener("editorViewUpdated", UpdateRulerRequestListener, false);
  }

  var bodyElement = GetBodyElement();
  var isFocusNode = true;
  var tmp;
  var tag = gLastFocusNode.nodeName.toLowerCase();

  toolbar.firstChild.removeAttribute("style");
  var button;
  do {
    tag = element.nodeName.toLowerCase();

    // <Kaze>
    //~ button = document.createElementNS(XUL_NS, "toolbarbutton");
    //~ button.setAttribute("label",   "<" + tag + ">");
    //~ button.setAttribute("value",   tag);
    // Let's add "id" and "class" attributes in the tag
    // and other attributes in the tooltip
    button = newStructToolbarButton(tag, element.attributes);
    // </Kaze>
    button.setAttribute("context", "structToolbarContext");
    button.className = "struct-button";

    toolbar.insertBefore(button, toolbar.firstChild);

    button.addEventListener("command", newCommandListener(element), false);
    button.addEventListener("contextmenu", newContextmenuListener(button, element), false);
    // <Kaze>
    //~ button.addEventListener("click", newCommandListener(element), false);
	//~ button.addEventListener("click", onStructToolbarClick, false);
	//~ button.addEventListener("dblclick", onStructToolbarClick, false);
    // </Kaze>

    if (isFocusNode && oneElementSelected) {
      button.setAttribute("checked", "true");
      isFocusNode = false;
    }

    tmp = element;
    element = element.parentNode;

  } while (tmp != bodyElement);

}
// Other Structure Toolbar hacks (very buggy, disabled in the overlay)
function StructSelectTag2(tag) {
	SelectFocusNodeAncestor(gContextMenuFiringDocumentElement);
	var node = gContextMenuFiringDocumentElement;
	var type = node.nodeType;
	//~ var prev = node;
	while (node) try {
		switch (tag) {
			case 'parent':
				node = node.parentNode;
				break;
			case 'child':
				node = node.firstChild;
				break;
			case 'next':
				node = node.nextSibling;
				break;
			case 'previous':
				node = node.previousSibling;
				break;				
		}
		if (node.nodeType == type) {
			SelectFocusNodeAncestor(node);
			node = null;
		}
	} catch (e) {};
}
function StructSelectNextTag() {
	SelectFocusNodeAncestor(gContextMenuFiringDocumentElement);
	var node = gContextMenuFiringDocumentElement;
	var type = node.nodeType;
	var next = node;
	
	while (next = next.nextSibling) try {
		if (next.nodeType == type) {
			SelectFocusNodeAncestor(next);
			next = null;
		}
	} catch (e) {};
	
	if (next)
		UpdateStructToolbar();
}
function StructSelectPreviousTag() {
	SelectFocusNodeAncestor(gContextMenuFiringDocumentElement);
	var node = gContextMenuFiringDocumentElement;
	var type = node.nodeType;
	var prev = node;
	while (prev = prev.previousSibling) try {
		if (prev.nodeType == type) {
			SelectFocusNodeAncestor(prev);
			prev = null;
		}
	} catch (e) {};
	
/* 	try {
		//~ var prev = node.previousSibling.previousSibling;
		var prev = node.previousSibling;
		alert(prev.nodeType);
		if (prev)
			SelectFocusNodeAncestor(prev);
	} catch (e) {}; */
  //~ SelectFocusNodeAncestor(gContextMenuFiringDocumentElement.previousSibling);
}
function StructSelectParentTag() {
	SelectFocusNodeAncestor(gContextMenuFiringDocumentElement);
	var node = gContextMenuFiringDocumentElement;
	try {
		var parent = node.parentNode;
		if (parent)
			SelectFocusNodeAncestor(parent);
	} catch (e) {};
  //~ SelectFocusNodeAncestor(gContextMenuFiringDocumentElement.previousSibling);
}
function StructSelectChildTag() {
	SelectFocusNodeAncestor(gContextMenuFiringDocumentElement);
	var node = gContextMenuFiringDocumentElement;
	try {
		var child = node.firstChild.nextSibling;
		if (child)
			SelectFocusNodeAncestor(child);
	} catch (e) {};
  //~ SelectFocusNodeAncestor(gContextMenuFiringDocumentElement.previousSibling);
}

//
// sandbox
/* function onTabClick() {
	alert("click !");
}
 */
/*       <method name="SelectTabEditor">
        <body>
        <![CDATA[
          GetCurrentEditingSession().setEditorOnControllers(window.content, GetCurrentEditor());
          var current = this.selectedPanel;
          this.setContentFrameId(current);

          window.UpdateWindowTitle();

          window.updateCommands("save");
          window.updateCommands("undo");
          window.updateCommands("select");
          window.updateCommands("style");
          window.goUpdateCommand("cmd_dtdStrictness");
          window.goUpdateCommand("cmd_dtdStrictness2");

          if (current.hasAttribute("displaymode"))
            window.SetEditMode(current.getAttribute("displaymode"));
          else
            window.SetEditMode(0);
          if (current.getAttribute("blockoutlines"))
            window.document.getElementById("blockOutlines").setAttribute("checked", true);
          else
            window.document.getElementById("blockOutlines").removeAttribute("checked");
        ]]>
        </body>
      </method>
 */
//
// Notes
/* comm.jar
	/EditorApplicationOverlay.js
		editPage(url, launchWindow, delay, newTab)
			open a file in Nvu
	/ComposerCommands.js
		SaveDocument(aSaveAs, aSaveCopy, aMimeType)
			save a file
*/
/* File IO : flags & modes
	var outputStream = Components.classes["@mozilla.org/network/file-output-stream;1"]
		.createInstance( Components.interfaces.nsIFileOutputStream );
	outputStream.init( file, 0x04 | 0x08 | 0x20, 420, 0 );
*/		
	/* Open flags 
	#define PR_RDONLY       0x01
	#define PR_WRONLY       0x02
	#define PR_RDWR         0x04
	#define PR_CREATE_FILE  0x08
	#define PR_APPEND      0x10
	#define PR_TRUNCATE     0x20
	#define PR_SYNC         0x40
	#define PR_EXCL         0x80
	*/
	/* File modes ....
	**
	** CAVEAT: 'mode' is currently only applicable on UNIX platforms.
	** The 'mode' argument may be ignored by PR_Open on other platforms.
	**
	**   00400   Read by owner.
	**   00200   Write by owner.
	**   00100   Execute (search if a directory) by owner.
	**   00040   Read by group.
	**   00020   Write by group.
	**   00010   Execute by group.
	**   00004   Read by others.
	**   00002   Write by others
	**   00001   Execute by others.
	**
	*/
